// Copyright (c) Microsoft Corporation. 
// Licensed under the MIT license. 

#include <string>
#include <stdlib.h>
#include <filesystem>
#include <future>
#include "SimplygonLoader.h"


void DisplacementCasting(Simplygon::ISimplygon* sg)
{
	Simplygon::spSceneImporter sgSceneImporter = sg->CreateSceneImporter();
	sgSceneImporter->SetImportFilePath( "../Assets/Wall/wall.obj" );
	if(!sgSceneImporter->RunImport())
		throw std::exception("Failed to load Wall/wall.obj.");
	Simplygon::spScene sgScene = sgSceneImporter->GetScene();

	// Create the reduction processor. 
	Simplygon::spReductionProcessor sgReductionProcessor = sg->CreateReductionProcessor();

	sgReductionProcessor->SetScene( sgScene );

	Simplygon::spReductionSettings sgReductionSettings = sgReductionProcessor->GetReductionSettings();
	Simplygon::spMappingImageSettings sgMappingImageSettings = sgReductionProcessor->GetMappingImageSettings();

	// Set reduction target to triangle ratio with a ratio of 50%. 
	sgReductionSettings->SetReductionTargets( Simplygon::EStopCondition::All, true, false, false, false );
	sgReductionSettings->SetReductionTargetTriangleRatio( 0.5f );

	// Generates a mapping image which is used after the reduction to cast new materials to the new 
	// reduced object. 
	sgMappingImageSettings->SetGenerateMappingImage( true );
	sgMappingImageSettings->SetApplyNewMaterialIds( true );
	sgMappingImageSettings->SetGenerateTangents( true );
	sgMappingImageSettings->SetUseFullRetexturing( true );

	Simplygon::spMappingImageOutputMaterialSettings sgOutputMaterialSettings = sgMappingImageSettings->GetOutputMaterialSettings(0);

	// Setting the size of the output material for the mapping image. This will be the output size of the 
	// textures when we do material casting in a later stage. 
	sgOutputMaterialSettings->SetTextureWidth( 2048 );
	sgOutputMaterialSettings->SetTextureHeight( 2048 );

	// Start the reduction process. 
	sgReductionProcessor->RunProcessing();

	// Setup and run the displacement material casting. 
	Simplygon::spDisplacementCaster sgDisplacementCaster = sg->CreateDisplacementCaster();
	sgDisplacementCaster->SetMappingImage( sgReductionProcessor->GetMappingImage() );
	sgDisplacementCaster->SetSourceMaterials( sgScene->GetMaterialTable() );
	sgDisplacementCaster->SetSourceTextures( sgScene->GetTextureTable() );
	sgDisplacementCaster->SetOutputFilePath( "DisplacementTexture" );

	Simplygon::spDisplacementCasterSettings sgDisplacementCasterSettings = sgDisplacementCaster->GetDisplacementCasterSettings();
	sgDisplacementCasterSettings->SetMaterialChannel( "Displacement" );
	sgDisplacementCasterSettings->SetGenerateScalarDisplacement( true );
	sgDisplacementCasterSettings->SetGenerateTangentSpaceDisplacement( false );
	sgDisplacementCasterSettings->SetOutputImageFileFormat( Simplygon::EImageOutputFormat::PNG );
	sgDisplacementCasterSettings->SetOutputPixelFormat( Simplygon::EPixelFormat::R8G8B8 );

	sgDisplacementCaster->RunProcessing();
	std::string displacementTextureFilePath = sgDisplacementCaster->GetOutputFilePath();

	// Update scene with new casted texture. 
	Simplygon::spMaterialTable sgMaterialTable = sg->CreateMaterialTable();
	Simplygon::spTextureTable sgTextureTable = sg->CreateTextureTable();
	Simplygon::spMaterial sgMaterial = sg->CreateMaterial();
	Simplygon::spTexture sgDisplacementTexture = sg->CreateTexture();
	sgDisplacementTexture->SetName( "Displacement" );
	sgDisplacementTexture->SetFilePath( displacementTextureFilePath.c_str() );
	sgTextureTable->AddTexture( sgDisplacementTexture );

	Simplygon::spShadingTextureNode sgDisplacementTextureShadingNode = sg->CreateShadingTextureNode();
	sgDisplacementTextureShadingNode->SetTexCoordLevel( 0 );
	sgDisplacementTextureShadingNode->SetTextureName( "Displacement" );

	sgMaterial->AddMaterialChannel( "Displacement" );
	sgMaterial->SetShadingNetwork( "Displacement", sgDisplacementTextureShadingNode );

	sgMaterialTable->AddMaterial( sgMaterial );

	sgScene->GetTextureTable()->Clear();
	sgScene->GetMaterialTable()->Clear();
	sgScene->GetTextureTable()->Copy(sgTextureTable);
	sgScene->GetMaterialTable()->Copy(sgMaterialTable);

	Simplygon::spSceneExporter  sgSceneExporter = sg->CreateSceneExporter();
	sgSceneExporter->SetScene(sgScene);
	sgSceneExporter->SetExportFilePath( "Output.fbx" );
	if(!sgSceneExporter->RunExport())
		throw std::exception("Failed to save Output.fbx.");

}

void main()
{
	Simplygon::ISimplygon* sg = NULL;
	Simplygon::EErrorCodes initval = Simplygon::Initialize( &sg );
	if( initval != Simplygon::EErrorCodes::NoError )
	{
		return;
	}

	DisplacementCasting(sg);

	Simplygon::Deinitialize(sg);
}

